Package: CCWeights
Type: Package
Title: Perform Weighted Linear Regression for Calibration Curve
Version: 0.1.6
Author: Yonghui Dong
Maintainer: Yonghui Dong <yonghui.dong@gmail.com>
Description: Automated assessment and selection of weighting factors for accurate quantification using linear calibration curve. 
 In addition, a 'shiny' App is provided, allowing users to analyze their data using an interactive graphical user interface, without any programming requirements.
Depends: R (>= 3.5.0)
Imports: plotly, dplyr, stats, magrittr, shiny, bs4Dash, fresh, DT,
        tools, readxl, rmarkdown, readr
License: GPL-3
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.2
NeedsCompilation: no
Packaged: 2021-11-09 21:26:31 UTC; dong
Repository: CRAN
Date/Publication: 2021-11-09 21:40:02 UTC
Built: R 4.6.0; ; 2026-04-25 12:49:48 UTC; unix

# Welcome to CCWeights <img src='https://github.com/YonghuiDong/CCWeights/blob/main/inst/shiny/Gui/mds/pix/logo.png' align="right" height="130"/>

[![CRAN status](http://www.r-pkg.org/badges/version/CCWeights)](https://cran.r-project.org/package=CCWeights) 

Calibration curves are used to understand the instrumental response to an analyte and predict the concentration in an unknown sample. A well-established and interpreted calibration curve is essential for any analytical methodology. 

**CCweights</span>** is a web-based tool (also an R package), which provides automated and efficient data analysis workflow to evaluate and select the best weighting factor for linear calibration curve and quantify targeted analytes accordingly. 

CCWeights can be applied for any analytical assays, in which linear calibration curves are used for quantification. For instance, Ultraviolet-visible spectroscopy- and liquid/gas chromatography mass spectrometry-based quantitative studies.

# Installation

1. stable version

```r
install.packages("CCWeights")
```

2. development version

```
require(devtools)
install_github("YonghuiDong/CCWeights")
```

Note: you need to install R package `bs4Dash` version <= 0.50 in order to run CCWeights shiny app locally. Please refer to section [Known Issues](#known-issues) for more details.

# Workflow

Below is an overview of CCWeights workflow:

<img src="https://github.com/YonghuiDong/CCWeights/blob/main/inst/shiny/Gui/mds/pix/workflow.png" width = "50%"/>

<em>Figure 1. Schematic workflow of CCWeights</em>

**Data Preparation:** 

- Data must contain at least two columns, one is `Concentration`, and another one is `Response`. In case you have more than one compound in your sample, you need to have a third column called `Compound`. If internal standards are used (e.g., stable isotope labeled internal standards), please include another column named `IS`, with the corresponding response value filled in the cell. 

- Use `unknown` for compounds with `Concentrations` to be determined in samples.

- Data with known `Concentration` will be regarded as calibration standards for calibration curve construction and evaluation.

- Data with `unknown` concentration will be regarded as unknown samples, and the `Concentration` will be predicted.
  
- You can refer to the example data in the **Upload Data** tab or **Figure 2** for the data format.
  
- You can also **[<b><span style="color:#F17F42">download the templates here</span></b>](https://github.com/YonghuiDong/CCWeights/tree/main/inst/shiny/Templete)** to prepare your data accordingly.

<img src="https://github.com/YonghuiDong/CCWeights/blob/main/inst/shiny/Gui/mds/pix/datafile.png" width="50%"/>

<em>Figure 2. Data format requirement</em>

- Once data file is successfully uploaded, you can perform data analysis following the steps shown in Figure 1.

## Known Issues

Due to substantial breaking changes in the API of R package `bs4Dash`, CCWeights, built with bs4Dash (version <= 0.5.0), is not compatible with v2.0.0. Therefore, users need to install the old version in order to run the shiny App of CCWeights locally.

There are two simple ways to install the old version of `bs4Dash`:

#### 1. Using devtools to install the older package version

```r
require(devtools)
install_version("bs4Dash", version = "0.5.0", repos = "http://cran.us.r-project.org")
```

#### 2. Installing an older package from source

You can download the old version (e.g., v0.5.0) [here](https://cran.r-project.org/src/contrib/Archive/bs4Dash/), and install it manually.

## Citation

If you find `CCWeights` useful, please consider citing our publication :smiley::

- CCWeights: An R package and web application for automated evaluation and selection of weighting factors for accurate quantification using linear calibration curve.

<br></br>

fluidRow(

  column(width = 12,

         bs4Card(
           width = 12,
           title = "Instruction",
           status = "secondary",
           solidHeader = FALSE,
           collapsible = TRUE,
           collapsed = FALSE,
           closable = FALSE,
           p("It has been suggested that a weighting factor should only be used when homoscedasticity is not met for analytical data.
             CCWeights first tests data homoscedasticity by calculating the probability that the variance of measurements at the highest
             concentration level is smaller than the variance of measurements at the lowest concentration level using an F-test."),
           p("The test of homoscedasticity is accepted when", span("Experimental F value", style = "color:#f15c42"), "is smaller than corresponding",
             span("Critical F value (or F Table value)", style = "color:#f15c42"), "at confidence of", span("99% (i.e., 1 - p-value).", style = "color:#f15c42")),
           p("1. You can customize the p-value to test the homoscedasticity of your dataset."),
           p("2. You can click", strong('+'), "and", strong('-'), "in the tab to show or hide the contents in the tab.")
           )
         ),

  column(width = 3,

         bs4Card(
           width = 12,
           inputId = "homoTest_card",
           title = "Homoscedasticity Test Parameters",
           status = "primary",
           solidHeader = FALSE,
           collapsible = FALSE,
           collapsed = FALSE,
           closable = FALSE,
           numericInput("pval_cutoff", strong("p-value threshold"), value = 0.01, min = 0, max = 1, step = 0.01),
           actionButton("homoTest", "Start Test", icon("paper-plane"),
                        style="color: #fff; background-color: #CD0000; border-color: #9E0000")
           )
         ),

  column(width = 9,

         bs4Card(
           width = 12,
           inputId = "homoResult_card",
           title = "Homoscedasticity Test Result",
           status = "secondary",
           solidHeader = FALSE,
           collapsible = TRUE,
           collapsed = FALSE,
           closable = FALSE,
           DT::dataTableOutput("homescedasticityResult")
           )
         )
  )

my_theme <- create_theme(

  # navbar

  bs4dash_vars(
    navbar_dark_color = "#FFFFFF",
    navbar_dark_active_color = "#F17F42",
    navbar_dark_hover_color = "#F17F42"
  ),

  # main bg

  bs4dash_layout(
    main_bg = "#FFFFFF"
  ),

  # sidebar

  bs4dash_sidebar_dark(
    bg = "#9DC8C8",
    color = "#FFFFFF",
    hover_color = "#F17F42",
    active_color = "000000",

    # submenu

    submenu_bg = "#9DC8C8",
    submenu_active_color = "#000000",
    submenu_active_bg = "#F17F42",
    submenu_color = "#FFFFFF",
    submenu_hover_color = "#F17F42"
  ),

  # status

  bs4dash_status(
    primary = "#9DC8C8", warning = "#F17F42"
  )
)

fluidRow(

  column(width = 12,

         bs4Card(
           width = 12,
           title = "Instruction",
           status = "secondary",
           solidHeader = FALSE,
           collapsible = TRUE,
           collapsed = FALSE,
           closable = FALSE,
           p("In this section you can quantify your samples based on the calibration curve."),
           p("Data with", span("unknown", style = "color:#f15c42"), "concentration is quantified here."),
           p("Although optimum weighting scheme has been suggested, here different weighting schemes including the user defined one if available,
             are used to quantify each compound in the sample. This allows the user to compare the results and make their final desicion."),
           p("1. You can click", strong("Quantify"), "button to perform calibration."),
           p("2. Subsequently, you can save the result by clicking the", strong("Save Result"), "button."),
           p("3. Note: ", span("when sample responses fall out of the linear range, the predicted concentrations are under- or over-estimated", style = "color:#f15c42"),
             ".Therefore, we have included a column named", span("Attention", style = "color:#f15c42"), "in the result file. If the sample response is within the linear range,",
             span("Attention = no;", style = "color:#f15c42"), "otherwise,", span("Attention = response out of calibration range.",style = "color:#f15c42"),
             "Users should carefully examine the quantification results in this case."),
           p("4. Note: ", span("when the user defined weighting factor is not available",  style = "color:#f15c42"), ", quantification will not be perfromed and analyte concentration
             will remain unknown under this weighting factor in the result.")
           )
         ),

  column(width = 3,

         bs4Card(
           width = 12,
           inputId = "caliResult_card",
           title = "Perform Quantification",
           status = "primary",
           solidHeader = FALSE,
           collapsible = FALSE,
           collapsed = FALSE,
           closable = FALSE,
           p("Perform calibration with different weights"),
           actionButton("caliDo", "Quantify", icon("paper-plane"),
                        style="color: #fff; background-color: #CD0000; border-color: #9E0000")
         ),

         bs4Card(
           width = 12,
           inputId = "caliResult_card",
           title = "Save Quantification Result",
           status = "primary",
           solidHeader = FALSE,
           collapsible = FALSE,
           collapsed = FALSE,
           closable = FALSE,
           p("Quantification results can be downloaded in csv format"),
           shinyjs::hidden(downloadButton("caliSave", "Save Result", icon("download"),
                                          style="color: #fff; background-color: #0091ff; border-color: #0091ff"))
           )
         ),

  column(width = 9,

         bs4Card(
           width = 12,
           inputId = "caliResult_card",
           title = "Quantification Result",
           status = "secondary",
           solidHeader = FALSE,
           collapsible = TRUE,
           collapsed = FALSE,
           closable = FALSE,
           DT::dataTableOutput("caliResult")
           )
         )
  )

# F-test Function

pval_selected <- reactive(
  return(input$pval_cutoff)
)

observeEvent(input$homoTest, {

  output$homescedasticityResult <- renderDataTable({

    validate(need(nrow(userInput()) > 0, "No data"))
    datatable(CCWeights::doFtest(DF = userInput(), p = pval_selected()),
              class = 'cell-border stripe',
              rownames = FALSE,
              options = list(scrollX = TRUE))
    })

  })

source("helpers.R")
source("themes.R")

bs4DashPage(
  old_school = FALSE,
  sidebar_min = TRUE,
  sidebar_collapsed = FALSE,
  controlbar_collapsed = TRUE,
  controlbar_overlay = TRUE,
  title = "CCWeights",

  ## NAVBAR ----------------------------------------------------------------------

  bs4DashNavbar(
    skin = "dark",
    status = "primary",
    border = TRUE,
    sidebarIcon = "chevron-left",
    controlbarIcon = "th",
    fixed = FALSE
    ),

  ## SIDEBAR ----------------------------------------------------------------------

  bs4DashSidebar(
    skin = "dark",
    status = "warning",
    title = HTML("<b>CCWeights</b>"),
    brandColor = "warning",
    src = "https://github.com/YonghuiDong/CCWeights/blob/main/inst/shiny/Gui/mds/pix/logo.png?raw=true",
    elevation = 3,
    opacity = 0.8,

    bs4SidebarMenu(

      bs4SidebarMenuItem("Home", tabName = "home", icon = "home"),
      bs4SidebarMenuItem("Upload Data", tabName = "inputdata", icon = "upload"),
      bs4SidebarMenuItem("Homoscedasticity Test", tabName = "homoscedasticity", icon = "check"),
      bs4SidebarMenuItem("Weights Test", tabName = "weights", icon = "balance-scale"),
      bs4SidebarMenuItem("Quantification", tabName = "quantification", icon = "chart-bar"),
      bs4SidebarMenuItem("Contact", tabName = "contact", icon = "user")
      )
    ),

  ## BODY ----------------------------------------------------------------------

  bs4DashBody(

    use_theme(my_theme),

    bs4TabItems(

      bs4TabItem("home",
                 source("ui-tab-landing.R", local=TRUE)$value),
      bs4TabItem("inputdata",
                 source("ui-tab-inputdata.R", local=TRUE)$value),
      bs4TabItem("homoscedasticity",
                 source("ui-tab-homoscedasticity.R", local=TRUE)$value),
      bs4TabItem("weights",
                 source("ui-tab-weights.R", local=TRUE)$value),
      bs4TabItem("quantification",
                 source("ui-tab-calibration.R", local=TRUE)$value),
      bs4TabItem("contact",
                 source("ui-tab-contact.R", local=TRUE)$value)
      ) # bs4TabItems
    ), # bs4DashBody

  ## FOOTER ----------------------------------------------------------------------

  bs4DashFooter(

    fluidRow(
      column(
        width = 12,
        align = "center",
        "Blavatnik Center for Drug Discovery (BCDD)",
        br(),
        "Tel Aviv University",
        br(),
        "Copyright (C) 2021, code licensed under GPL-3.0",
        br()
        )
      ),
    right_text = NULL
    )
  ) # bs4DashPage

#weights

observe({

  if(!is.null((userInput()))){
    x <- unique(userInput()$Compound)
    updateSelectInput(session,
                      "selected_compound",
                      choices = x,
                      selected = x[1])
  }
})


selectedDF <- reactive({
  userInput()[userInput()$Compound == input$selected_compound, ]
})


## user defined weights

userWeights <- reactive({
  if(shiny::isTruthy(input$userWeights)){
    return(input$userWeights)
  }
})

observeEvent(input$evaluate, {

  shiny::withProgress(message = 'Evaluation in progress',
                      detail = 'It may take a while...', value = 0.7,{


                        output$Weights_recommondation <- renderDataTable({

                          shiny::validate(need(nrow(selectedDF()) > 0, "No data"))
                          datatable(cbind.data.frame("p-value used" = pval_selected(),
                                                     CCWeights::doEvaluation(selectedDF(), p = pval_selected(), userWeights =  userWeights())),
                                    class = 'cell-border stripe',
                                    rownames = FALSE,
                                    options = list(scrollX = TRUE))
                        })


                        output$weightPlot1 <- renderPlotly({

                          validate(need(nrow(selectedDF()) > 0, "No data"))
                          CCWeights::doWlm(selectedDF(), weights = NULL)$figResult

                        })

                        output$weightPlot2 <- renderPlotly({

                          validate(need(nrow(selectedDF()) > 0, "No data"))
                          CCWeights::doWlm(selectedDF(), weights = "1/x")$figResult

                        })

                        output$weightPlot3 <- renderPlotly({

                          validate(need(nrow(selectedDF()) > 0, "No data"))
                          CCWeights::doWlm(selectedDF(), weights = "1/x^2")$figResult

                        })

                        output$weightPlot4 <- renderPlotly({

                          validate(need(nrow(selectedDF()) > 0, "No data"))
                          CCWeights::doWlm(selectedDF(), weights = "1/y")$figResult

                        })

                        output$weightPlot5 <- renderPlotly({

                          validate(need(nrow(selectedDF()) > 0, "No data"))
                          CCWeights::doWlm(selectedDF(), weights = "1/y^2")$figResult

                        })


                        output$weightPlot6 <- renderPlotly({

                          validate(need(!is.null(userWeights()), "No defined weights from user"))
                          validate(need(nrow(selectedDF()) > 0, "No data"))

                          ## skip the wrong input weights
                          if(inherits(try(CCWeights::doWlm(selectedDF(), weights = userWeights())$figResult, silent = TRUE), "try-error")){NULL
                          } else {
                            CCWeights::doWlm(selectedDF(), weights = userWeights())$figResult
                          }

                        })
                      })
  })

fluidRow(

  column(width = 12,

         bs4Card(
           width = 12,
           title = "Instruction",
           status = "secondary",
           solidHeader = FALSE,
           collapsible = TRUE,
           collapsed = FALSE,
           closable = FALSE,
           p("1. You can upload your data in", strong("Upload Data Panel"), "tab. CCWeights accepts csv, xls and xlsx formats."),
           p("2. Your data should contain at least two columns, i.e.,", span("Concentration", style = "color:#f15c42"), "and", span("Response", style = "color:#f15c42"),
             ". If your data contains information from more than one compounds, you need to add an additional column, named", span("Compound", style = "color:#f15c42"),
             ". If you have internal standards in your data, you need to add a column named", span("IS", style = "color:#f15c42"), ". Note that column names
             are case-sensitive."),
           p("3. You can load the two example datasets in", strong("Upload Data Panel"), "tab to check the data format."),
           p("4. You can view the data in", strong("Loaded Data"), "tab,
             and view the summary statistics of the loaded data in", strong("Data Summary"), "."),
           p("5. You can click", strong('+'), "and", strong('-'), "in the tab to show or hide the contents in the tab.")
           )
         ),


  column(width = 3,

         bs4Card(
           width = 12,
           inputId = "input_card",
           title = "Upload data panel",
           status = "primary",
           solidHeader = FALSE,
           collapsible = FALSE,
           collapsed = FALSE,
           closable = FALSE,
           radioButtons("example_data", "Do you want to view the example data?",
                        choices = c("Yes" = 'yes',
                                    "No, upload my data" = 'umd'),
                        selected = 'yes'),
           conditionalPanel(condition = "input.example_data == 'yes'",
                            radioButtons("example_dataset", "Please choose an example dataset:",
                                         choices = c("Example without internal standard" = 'nostd',
                                                     "Example with internal standard" = 'std'
                                                     ),
                                         selected = 'nostd')
                            ),
           conditionalPanel(condition = "input.example_data == 'umd'",
                            fileInput("target","Upload your file (csv/xls/xlsx format):")
                            ),
           actionButton("upload_data", "Submit", icon("paper-plane"),
                        style="color: #fff; background-color: #CD0000; border-color: #9E0000"
                        )
           )
         ),


  column(width = 9,
         bs4Card(
           width = 12,
           inputId = "rawData_card",
           title = "Loaded Data",
           status = "secondary",
           solidHeader = FALSE,
           collapsible = TRUE,
           collapsed = FALSE,
           closable = FALSE,
           DT::dataTableOutput("rawData")
           ),

         bs4Card(
           width = 12,
           inputId = "summary_card",
           title = "Data Summary",
           status = "secondary",
           solidHeader = FALSE,
           collapsible = TRUE,
           collapsed = TRUE,
           closable = FALSE,
           DT::dataTableOutput("summaryData")
           )
         )
  )

userWeightsexist <- reactive({
  if(is.null(userWeights())){
  return("user: None")
  } else {
    return(userWeights())
  }
})

observeEvent(input$caliDo, {

  shiny::validate(need(nrow(userInput()) > 0, "No data"))

  suppressWarnings(

    shiny::withProgress(message = 'Quantification in progress',
                        detail = 'It may take a while...', value = 0.3,{

                          M1 <- userInput() %>%
                            dplyr::group_by(Compound) %>%
                            dplyr::do(CCWeights::doCalibration(., weights = NULL))

                          M2 <- userInput() %>%
                            dplyr::group_by(Compound) %>%
                            dplyr::do(CCWeights::doCalibration(., weights = "1/x"))

                          M3 <- userInput() %>%
                            dplyr::group_by(Compound) %>%
                            dplyr::do(CCWeights::doCalibration(., weights = "1/x^2"))

                          M4 <- userInput() %>%
                            dplyr::group_by(Compound) %>%
                            dplyr::do(CCWeights::doCalibration(., weights = "1/y"))

                          M5 <- userInput() %>%
                            dplyr::group_by(Compound) %>%
                            dplyr::do(CCWeights::doCalibration(., weights = "1/y^2"))

                          M6 <- userInput() %>%
                            dplyr::group_by(Compound) %>%
                            dplyr::do(CCWeights::doCalibration(., weights =  userWeightsexist()))

                          CaliFinal <- rbind.data.frame(M1, M2, M3, M4, M5, M6)

                          output$caliResult <- renderDataTable({
                            datatable(CaliFinal,
                                      class = 'cell-border stripe',
                                      rownames = FALSE,
                                      options = list(scrollX = TRUE))
                          })

                          output$caliSave<- downloadHandler(
                            filename = function() {
                              paste("quantificationResults", ".csv", sep="")
                            },
                            content = function(file) {
                              write.csv(CaliFinal, file, row.names = FALSE)
                            }
                          )

                        })
    )
  })

shinyServer(function(input, output, session) {
  options(shiny.maxRequestSize = 100 * 1024^2) ## file size limit: 100MB
  source("server-inputdata.R",local = TRUE)
  source("server-homoscedasticity.R",local = TRUE)
  source("server-weights.R",local = TRUE)
  source("server-calibration.R",local = TRUE)
  }
)

#### load Data
userInput <- reactive({

  if(input$example_data == "yes") {

    if(input$example_dataset == "std"){
      target <- CCWeights::expData$STD
    } else{
      target <- CCWeights::expData$noSTD
    }
    return(target)
  }

  else if (input$example_data == "umd") {

    infile <- input$target

    if (is.null(infile)){
      return(NULL)
    }

    else {

      extension <- tools::file_ext(infile$name)
      filepath <- infile$datapath
      target = switch(extension,
                      csv = readr::read_csv(filepath),
                      xls = readxl::read_xls(filepath),
                      xlsx = readxl::read_xlsx(filepath)
      )

      # Assign the compound name if it is not specified
      if (is.null(target$Compound)) {target$Compound = "X"}
      return(as.data.frame(target))
    }
  }
})


observeEvent(input$upload_data, {

  output$rawData <- DT::renderDataTable({

    shiny::validate(need(all(c("Concentration", "Response") %in% colnames(userInput())),
                         "You data should contain at least 'Concentration' and 'Response' columns"))

    datatable(userInput(),
              class = 'cell-border stripe',
              rownames = FALSE,
              filter = "top",
              extensions = 'Buttons'
              )
    })

  output$summaryData <- DT::renderDataTable({

    shiny::validate(need(all(c("Concentration", "Response") %in% colnames(userInput())),
                         "You data should contain at least 'Concentration' and 'Response' columns"))

    # get summary
    dataSummary <- userInput() %>%
      dplyr::group_by(Compound, Concentration) %>%
      dplyr::summarise(Count = dplyr::n(), .groups = 'drop')

    datatable(dataSummary,
              options = list(ordering = FALSE),
              class = 'cell-border stripe',
              rownames = FALSE,
              extensions = 'Buttons',
              editable = FALSE
              )
    })

})

fluidRow(

  column(width = 12,

         bs4Card(
           width = 12,
           title = "Instruction",
           status = "secondary",
           solidHeader = FALSE,
           collapsible = TRUE,
           collapsed = FALSE,
           closable = FALSE,
           strong("*How is the best weighting factor selected?"),
           br(),
           p("(a)", span("If the data are homoscedastic,", style = "color:#f15c42"), "weighting factor = 1 (1/x^0, unweight linear regression) is suggested."),
           p("(b)", span("If the data are heteroscedastic,", style = "color:#f15c42"), "five commonly used weighting factors, i.e., 1/x^0, 1/x, 1/x^2, 1/y and 1/y^2,
             together with user-defined weighting factors (if present) are tested. By applying regression with different weighting
             factors on a set of calibration curve standard data, the best weighting factor is identified by choosing the
             one generating the smallest sum of the absolute relative errors (sum%RE)."),
           strong("*Instruction"),
           br(),
           p("1. The results are displayed for each compound, you can select the compound name in", strong("View Result"), "tab to check
             the corresponding result."),
           p("2. Additionally, you can define and test your own preferred weighting factors in", strong("Add your own weights"), "tab (e.g., 1/x^3).
             Don't worry if you input some wrong weighting schemes. CCWeights knows how to skip them."),
           p("3. Two types of results are given here. One is a summerized table, which contains the evaluation results of each model, and
             the suggested model. The residual and linear regression plots for each model are also provided here to allow the user
             to interactively visulize the results."),
           p("4. You can download the figures of interest in", span("svg", style = "color:#f15c42"), "format by clicking the", span("Camera", style = "color:#f15c42"), "icon (download plot) in the figure."),
           p("5. You can click", strong('+'), "and", strong('-'), "in the tab to show or hide the contents in the tab.")
           )
         ),

  column(width = 3,

         bs4Card(
           width = 12,
           inputId = "weightView_card",
           title = "View Result",
           status = "primary",
           solidHeader = FALSE,
           collapsible = FALSE,
           collapsed = FALSE,
           closable = FALSE,
           selectInput("selected_compound", label = "Select compound to view:", list()),
           p("Optionally: "),
           textInput("userWeights", label = "Add your own weights"),
           actionButton("evaluate", "Evaluate", icon("paper-plane"),
                        style="color: #fff; background-color: #CD0000; border-color: #9E0000")
           )

         ),


  column(width = 9,

         bs4Card(
           width = 12,
           inputId = "weightBest",
           title = "Recommondated weights for the selected compound",
           status = "secondary",
           solidHeader = FALSE,
           collapsible = TRUE,
           collapsed = FALSE,
           closable = FALSE,
           DT::dataTableOutput("Weights_recommondation")
           ),

         fixedRow(
           column(6,
                  box(
                    width = 12,
                    title = "Regression (red) and Residual (blue) Plots",
                    status = "secondary",
                    solidHeader = FALSE,
                    collapsible = TRUE,
                    collapsed = FALSE,
                    closable = FALSE,
                    plotlyOutput("weightPlot1")
                  ),

                  box(
                    width = 12,
                    title = "Regression (red) and Residual (blue) Plots",
                    status = "secondary",
                    solidHeader = FALSE,
                    collapsible = TRUE,
                    collapsed = FALSE,
                    closable = FALSE,
                    plotlyOutput("weightPlot2")
                  ),

                  box(
                    width = 12,
                    title = "Regression (red) and Residual (blue) Plots",
                    status = "secondary",
                    solidHeader = FALSE,
                    collapsible = TRUE,
                    collapsed = FALSE,
                    closable = FALSE,
                    plotlyOutput("weightPlot3")
                  )

           ),

           column(6,
                  box(
                    width = 12,
                    title = "Regression (red) and Residual (blue) Plots",
                    status = "secondary",
                    solidHeader = FALSE,
                    collapsible = TRUE,
                    collapsed = FALSE,
                    closable = FALSE,
                    plotlyOutput("weightPlot4")
                    ),

                  box(
                    width = 12,
                    title = "Regression (red) and Residual (blue) Plots",
                    status = "secondary",
                    solidHeader = FALSE,
                    collapsible = TRUE,
                    collapsed = FALSE,
                    closable = FALSE,
                    plotlyOutput("weightPlot5")
                  ),

                  box(
                    width = 12,
                    title = "@user defined weights",
                    status = "secondary",
                    solidHeader = FALSE,
                    collapsible = TRUE,
                    collapsed = FALSE,
                    closable = FALSE,
                    plotlyOutput("weightPlot6")
                  )
                  )
           )
         )
  )

# Welcome to CCWeights &nbsp;<img src='pix/logo.png' align="right" height="130"/>

Calibration curves are used to understand the instrumental response to an analyte and predict the concentration in an unknown sample. A well-established and interpreted calibration curve is essential for any analytical methodology. 

<b><span style="color:#F17F42">CCweights</span></b> is a web-based tool (also an R package), which provides automated and efficient data analysis workflow to evaluate and select the best weighting factor for linear calibration curve and quantify targeted analytes accordingly. 

CCWeights can be applied for any analytical assays, in which linear calibration curves are used for quantification. For instance, Ultraviolet-visible spectroscopy- and liquid/gas chromatography mass spectrometry-based quantitative studies.

---

# Workflow

Below is an overview of CCWeights workflow:

<img src="pix/workflow.png" width="45%"/>

<em>Figure 1. Schematic workflow of CCWeights</em>

**Data Preparation:** 

- Data must contain at least two columns, one is `Concentration`, and another one is `Response`. In case you have more than one compound in your sample, you need to have a third column called `Compound`. If internal standards are used (e.g., stable isotope labeled internal standards), please include another column named `IS`, with the corresponding response value filled in the cell. 

- Use `unknown` for compounds with `Concentrations` to be determined in samples.

- Data with known `Concentration` will be regarded as calibration standards for calibration curve construction and evaluation.

- Data with `unknown` concentration will be regarded as unknown samples, and the `Concentration` will be predicted.
  
- You can refer to the example data in the **Upload Data** tab or **Figure 2** for the data format.
  
- You can also **[<b><span style="color:#F17F42">download the templates here</span></b>](https://github.com/YonghuiDong/CCWeights/tree/main/inst/shiny/Templete)** to prepare your data accordingly.

<img src="pix/datafile.png" width="50%"/>

<em>Figure 2. Data format requirement</em>

- Once data file is successfully uploaded, you can perform data analysis following the steps shown in Figure 1.

---

# About CCWeights

CCWeights is publicly available on **[<b><span style="color:#F17F42">CRAN repository</span></b>](https://cran.r-project.org/web/packages/CCWeights/index.html)**, with source code available on **[<b><span style="color:#F17F42">GitHub</span></b>](https://github.com/YonghuiDong/CCWeights)** under a GPL-3 license. The web application can be run locally from R console using a simple command `runGui()`. Alternatively, the web application can be freely accessed for direct online use at **[<b><span style="color:#F17F42">https://bcdd.shinyapps.io/CCWeights/</span></b>](https://bcdd.shinyapps.io/CCWeights/)**. 

---
<a href= 'https://bcdd.tau.ac.il/'><img src='pix/Tau.png' alt='TAU' title='Tel Aviv University' width='500'/></a>

# Contact

------

### Report bugs:

To report bugs and/or request features, please use the following GitHub issue channel: 

[<b><span style="color:#F17F42">https://github.com/YonghuiDong/CCWeights/issues</span></b>](https://github.com/YonghuiDong/CCWeights/issues)

------

### Citation

If you find **CCWeights** useful, please consider citing our publication:

> CCWeights: An R package and web application for automated evaluation and selection of weighting factors for accurate quantification using linear calibration curve.


------
<a href= 'https://bcdd.tau.ac.il/'><img src='pix/Tau.png' alt='TAU' title='Tel Aviv University' width='500'/></a>
